use crate::lib::{randstr, env_uploads_dir, env_base_url};
use axum::{
    extract::Multipart,
    response::{IntoResponse, Response},
};
use tokio::{fs::create_dir_all, fs::File, io::AsyncWriteExt};

// upload view
pub async fn upload(mut multipart: Multipart) -> Response {
    let mut link = String::from("");

    while let Some(field) = multipart.next_field().await.unwrap() {
        let name = field.name().unwrap().to_string();
        let filename = field.file_name().unwrap().to_string();
        let data = field.bytes().await.unwrap();

        println!("Length of `{}` is {} bytes", name, data.len());
        // tracing::debug!("Length of `{}` is {} bytes", name, data.len());

        let fillo = randstr(); // directorio que aloxará o arquivo
        let pai = &fillo[0..1]; // agrupase por directorios co mesmo comezo (1ºchar)
        let path = format!("{}/{}/{}", env_uploads_dir(), pai, fillo);
        let dest = format!("{}/{}", path, filename);

        create_dir_all(&path)
            .await
            .expect("error creando directorios");
        let mut file = File::create(dest).await.expect("error creando arquivo");
        file.write_all(&data).await.expect("error gardando contido");

        link = format!("{}/f/{}", env_base_url(), fillo);
    }

    link.into_response()
}
